跳到主要内容

通过 Konva 开始使用 Angular 和 Canvas

Angular 如何使用 Canvas?

ng2-konva 是一个 JavaScript 库,可使用 Angular 绘制复杂的 Canvas 图形。它为 Konva 框架 提供声明式和响应式绑定。

GitHub 仓库

它尝试让 Angular 与 HTML5 Canvas 库配合使用。其目标是提供与普通 Angular 类似的声明式标记和数据流模型。

所有 ng2-konva 组件都对应带有 'ko-' 前缀的同名 Konva 组件。Konva 对象的所有可用参数都可以作为 config,添加到对应 ng2-konva 组件的属性绑定中。

核心图形包括:ko-rectko-circleko-ellipseko-lineko-imageko-textko-text-pathko-starko-labelko-pathko-regular-polygon。 你还可以创建 自定义图形

有关 Konva 的更多信息,请阅读 Konva 概述

对于 Angular 21 应用,普通静态 config 适合简单示例。如果通过图像加载等异步回调更新 config,请优先使用 Angular signals。

快速开始

需要 Angular 20 或更高版本。

1. 通过 npm 安装

npm install ng2-konva konva --save

2. 导入并使用 ng2-konva

import {
CoreShapeComponent,
StageComponent,
} from 'ng2-konva';

@Component({
// ... other config
standalone: true,
template: `
<ko-stage [config]="configStage">
<ko-layer>
<ko-circle [config]="configCircle"></ko-circle>
</ko-layer>
</ko-stage>
`,
imports: [StageComponent, CoreShapeComponent],
})
export default class App {
public configStage: StageConfig = {
width: window.innerWidth,
height: window.innerHeight,
};
public configCircle: CircleConfig = {
x: 100,
y: 100,
radius: 50,
fill: 'red',
};
}

3. 在组件中使用

操作说明:尝试拖动星形。拖动时,星形会放大。释放后,星形会恢复正常大小。

import { Component, OnInit, viewChild } from '@angular/core';
import Konva from 'konva';
import { StarConfig } from 'konva/lib/shapes/Star';
import { StageConfig } from 'konva/lib/Stage';
import {
  CoreShapeComponent,
  NgKonvaEventObject,
  StageComponent,
} from 'ng2-konva';

type ExtStartConfig = StarConfig & { startScale: number };

@Component({
  selector: 'app-root',
  standalone: true,
  template: `
    <ko-stage [config]="configStage">
      <ko-layer>
        @for (config of starConfigs; track trackConfig($index, config)) {
          <ko-star
            (dragstart)="handleDragstart($event.event)"
            (dragend)="handleDragend($event.event)"
            [config]="config"
          />
        }
      </ko-layer>
    </ko-stage>
  `,
  imports: [StageComponent, CoreShapeComponent],
})
export default class StarExampleComponent implements OnInit {
  public width = 800;
  public height = 800;
  public starConfigs: ExtStartConfig[] = [];

  public configStage: Partial<StageConfig> = {
    width: this.width,
    height: this.height,
  };

  public handleDragstart(
    event: NgKonvaEventObject<MouseEvent>,
  ): void {
    const shape = event.target;

    this.starConfigs = this.starConfigs.map((conf) => {
      if ( conf.name !== shape.name()) {
        return conf;
      }
      return {
        ...conf,
        shadowOffsetX: 15,
        shadowOffsetY: 15,
        scaleX: conf.startScale * 1.2,
        scaleY: conf.startScale * 1.2,
      };
    });
    this.starConfigs = [
      ...this.starConfigs.filter((conf) => conf.name !== shape.name()),
      this.starConfigs.find((conf) => conf.name === shape.name())!,
    ];
  }

  public handleDragend(
    event: NgKonvaEventObject<MouseEvent>,
  ): void {
    const shape = event.target;
    this.starConfigs = this.starConfigs.map((conf) => {
      if (conf.name !== shape.name()) {
        return conf;
      }
      return {
        ...conf,
        x: shape.x(),
        y: shape.y(),
        scaleX: conf.startScale,
        scaleY: conf.startScale,
      };
    });
  }

  trackConfig(index: number, config: ExtStartConfig): string | undefined {
    return config.name;
  }

  public ngOnInit(): void {
    for (let n = 0; n < 100; n++) {
      const scale = Math.random();
      this.starConfigs.push({
        x: Math.random() * this.width,
        y: Math.random() * this.height,
        rotation: Math.random() * 180,
        numPoints: 5,
        innerRadius: 30,
        outerRadius: 50,
        fill: '#89b717',
        opacity: 0.8,
        draggable: true,
        scaleX: scale,
        scaleY: scale,
        shadowColor: 'black',
        shadowBlur: 10,
        shadowOffsetX: 5,
        shadowOffsetY: 5,
        shadowOpacity: 0.6,
        startScale: scale,
        name: n.toString(),
      });
    }
  }
}

有关完整的属性和方法列表,请参阅 Konva API 参考

跳到主要内容

使用 Vue 和 Konva 开始 Canvas 开发

如何在 Vue 中使用 Canvas?

VueKonva 标志

Vue Konva 是一个使用 Vue 绘制复杂 Canvas 图形的 JavaScript 库。

它提供对 Konva 框架的声明式响应式绑定。

所有 vue-konva 组件都对应同名的 Konva 组件,并带有前缀 'v-'。Konva 对象支持的所有参数都可以作为 config 添加到对应 vue-konva 组件的 prop 中。

核心图形包括:v-rectv-circlev-ellipsev-linev-imagev-textv-text-pathv-starv-labelv-pathv-regular-polygon。 你还可以创建自定义图形

如需详细了解 Konva,请阅读 Konva 概览

快速开始

需要 Vue.js 3。

1. 通过 npm 安装

npm install vue-konva konva --save

2. 选择导入方式

可以通过两种方式使用 vue-konva

选项 A:全局注册(建议初学者使用)

使用插件全局注册所有组件:

import { createApp } from 'vue';
import App from './App.vue';
import VueKonva from 'vue-konva';

const app = createApp(App);
app.use(VueKonva);
app.mount('#app');

完成全局注册后,所有组件都可以使用 v- 前缀:v-stagev-layerv-rectv-circle 等。

选项 B:按需导入

仅导入需要的组件:

<template>
<v-stage :config="stageSize">
<v-layer>
<v-circle :config="circleConfig" />
</v-layer>
</v-stage>
</template>

<script setup>
import { Stage as VStage, Layer as VLayer, Circle as VCircle } from 'vue-konva';

const stageSize = {
width: 200,
height: 200
};

const circleConfig = {
x: 100,
y: 100,
radius: 70,
fill: 'red',
stroke: 'black',
strokeWidth: 4
};
</script>

3. 示例:可拖动星形

操作说明: 尝试拖动星形。拖动时,星形会放大。松开后,星形会恢复正常大小。

<template>
  <v-stage
    ref="stage"
    :config="stageSize"
    @dragstart="handleDragstart"
    @dragend="handleDragend"
  >
    <v-layer ref="layer">
      <v-star
        v-for="item in list"
        :key="item.id"
        :config="{
          x: item.x,
          y: item.y,
          rotation: item.rotation,
          id: item.id,
          numPoints: 5,
          innerRadius: 30,
          outerRadius: 50,
          fill: '#89b717',
          opacity: 0.8,
          draggable: true,
          scaleX: dragItemId === item.id ? item.scale * 1.2 : item.scale,
          scaleY: dragItemId === item.id ? item.scale * 1.2 : item.scale,
          shadowColor: 'black',
          shadowBlur: 10,
          shadowOffsetX: dragItemId === item.id ? 15 : 5,
          shadowOffsetY: dragItemId === item.id ? 15 : 5,
          shadowOpacity: 0.6
        }"
      />
    </v-layer>
  </v-stage>
</template>

<script setup>
import { ref, onMounted } from 'vue';

const stageSize = {
  width: window.innerWidth,
  height: window.innerHeight
};

const list = ref([]);
const dragItemId = ref(null);

const handleDragstart = (e) => {
  // save drag element:
  dragItemId.value = e.target.id();
  // move current element to the top:
  const item = list.value.find(i => i.id === dragItemId.value);
  const index = list.value.indexOf(item);
  list.value.splice(index, 1);
  list.value.push(item);
};

const handleDragend = () => {
  dragItemId.value = null;
};

onMounted(() => {
  for (let n = 0; n < 30; n++) {
    list.value.push({
      id: Math.round(Math.random() * 10000).toString(),
      x: Math.random() * stageSize.width,
      y: Math.random() * stageSize.height,
      rotation: Math.random() * 180,
      scale: Math.random()
    });
  }
});
</script>

或者使用 CDN

<html>
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no" />
<meta http-equiv="x-ua-compatible" content="ie=edge" />
</head>
<body>
<div id="app">
<v-stage ref="stage" :config="configKonva">
<v-layer ref="layer">
<v-circle :config="configCircle" />
</v-layer>
</v-stage>
</div>
<!--1. Link Vue Javascript & Konva-->
<script src="https://unpkg.com/vue@3/dist/vue.global.js"></script>
<script src="https://unpkg.com/konva@9/konva.min.js"></script>
<!--2. Link VueKonva Javascript (Plugin automatically installed)-->
<script src="https://unpkg.com/vue-konva@3/dist/vue-konva.umd.js"></script>
<script>
// 3. Create the Vue instance
const { createApp, ref } = Vue;
const VueKonva = window['vue-konva'].default;

const app = createApp({
setup() {
const configKonva = {
width: 200,
height: 200
};

const configCircle = {
x: 100,
y: 100,
radius: 70,
fill: 'red',
stroke: 'black',
strokeWidth: 4
};

return {
configKonva,
configCircle
};
}
});

app.use(VueKonva);
app.mount('#app');
</script>
</body>
</html>

跳到主要内容

React Canvas 库 — react-konva 入门

React Konva 标志 — React Canvas 库

react-konva 是一个用于绘制复杂 2D 图形的 React Canvas 库。它为 Konva 框架提供声明式绑定。你可以使用熟悉的 React 组件和数据流。

GitHub 仓库

使用 react-konva 时,你可以像编写 React DOM 一样编写 Canvas 图形。你可以使用 JSX 组件、props、state 和 hooks。

每个 Konva 图形都可以作为 React 组件使用。这些图形包括 Rect、Circle、Line、Text、Image 和 Star,并完整支持事件。

注意:react-konva 只能在浏览器中使用,不支持 React Native。 React Native 没有 DOM,也没有 <canvas> 元素,因此 Konva 没有可以绘制的目标。如果你在 Web 上已经有一个 Konva 编辑器,把它放进 WebView 中运行是可行的方案。如果是新的原生应用,请使用 React Native Skia

你可以在 konvajs.org 查看数十个交互式示例。Konva 的所有功能都可以通过 react-konva 在 React 中使用。

可以这样理解:Konvareact-konva 的关系,类似于 DOMReact 的关系。

安装

npm install react-konva konva --save

下面的基本示例创建一个包含多个图形的简单 Canvas:

import React from 'react';
import { Stage, Layer, Rect, Circle, Text } from 'react-konva';

const App = () => {
  return (
    <Stage width={window.innerWidth} height={window.innerHeight}>
      <Layer>
        <Text text="Try to drag shapes" fontSize={15} />
        <Rect
          x={20}
          y={50}
          width={100}
          height={100}
          fill="red"
          shadowBlur={10}
          draggable
        />
        <Circle
          x={200}
          y={100}
          radius={50}
          fill="green"
          draggable
        />
      </Layer>
    </Stage>
  );
};

export default App;

人们使用 react-konva 构建什么

大多数生产级 Canvas 应用可以分为几类。下面每个示例都可以运行,其中一些还并排展示了原生 JavaScript 和 Vue 版本: